-- BaBam V1.0.1. Written by OneBanana.
-- 
-- Grab a sledgehammer and load yourself up with medium stones
-- Use F8F8 camera view, zoomed in 100% with the screen locked (Alt+L) and pin open the Drop menu
-- Default to MAX for how many should be turned OFF.
-- Right-Click Pins/Unpins a Menu must be ON
-- Right-Click opens a Menu as Pinned should be turned OFF
-- Do not move from your starting position untill the script has stopped.
-- Before you begin collecting the stone fragments drop your sledgehammer otherwise you will not be able to 'hotclick' to collect them.
-- This also marks the spot to return to after you have collected the stone fragments if you wish to continue smashing.
-- For best results stand facing the bottom of the screen (South). This helps to prevent the script misclicking on your avatar while you are smashing
-- Enjoy :)
 
dofile("screen_reader_common.inc");
dofile("ui_utils.inc");


per_click_delay = 100;
waitDelay = 100;
up = nil;
right_click = nil;

button_names = {
"Smash Medium Stone",
"Smash Cracked Stone",
"Smash Broken Stone",
"Smash Split Stone",
"Smash Smashed Stone",
"Drop Medium Stone",
"Drop Cracked Stone",
"Drop Broken Stone",
"Drop Split Stone",
"Drop Smashed Stone"
};



   askForWindow("BamBam V 1.0. By OneBanana.                 Stone Smasher... Drop and Smash Medium, Cracked, Broken, Split & Smashed Stones into Gravel. You must be in F8F8 camera view, zoomed in 100% with the screen locked (Alt+L) and have your Drop menu pinned open. Default to MAX for how many should be turned OFF. Right-Click opens a Menu as Pinned should be turned OFF. Right-Click Pins/Unpins a Menu must be ON. Dont move from your starting position untill the script has stopped. Note...For best results stand facing the bottom of the screen (South).                                                                                                                                                                                                            Press Shift To Continue.");

function askText(ask_text)
	askForWindow("You must be in F8F8 camera view, zoomed in 100% with the screen locked (Alt+L) and have your Drop menu pinned open. Default to MAX for how many should be turned OFF. Right-Click opens a Menu as Pinned should be turned OFF. Right-Click Pins/Unpins a Menu must be ON. Dont move from your starting position untill the script has stopped. To 'hotclick' the fragments for collection you will need to drop your sledgehammer, (also marks the spot to return to after gathering if you wish to continue smashing). *For best results stand facing the bottom of the screen (South).     Click in ATITD window and hit shift to begin.");

end

function promptDelays()
	y = y + 40;
        lsPrint(5, y, 0, 0.8, 0.8, 0xffffffff, "Passes:");
        is_done, num_loops = lsEditBox("num_loops", 170, y, 0, 50, 30, 1.0, 1.0, 0x000000ff, 10);
        num_loops = tonumber(num_loops);
        if not num_loops then
        is_done = false;
        lsPrint(10, y+22, 10, 0.7, 0.7, 0xFF2020ff, "MUST BE A NUMBER");
        num_loops = 10;	
	end
end

function waitForChange()
	local c=0;
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
	end
end

function clickAll(image_name, up)
	-- Find buttons and click them!
	srReadScreen();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		return nil;
	else
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		lsSleep(50);
		return 1;
	end
end

function clickAllRight(image_name)
	-- Find windows and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	if #buttons == 0 then
		statusScreen("Could not find any pinned up windows...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "windows(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, true);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, true);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " windows).");
		lsSleep(100);
	end
end

function refocus()
	statusScreen("Refocusing...");
	for i=2, #window_locs do
		setWaitSpot(window_locs[i][0], window_locs[i][1]);
		srClickMouseNoMove(window_locs[i][0] + 321, window_locs[i][1] + 74);
		waitForChange();
	end
end

function Unpin()
	askForWindow("Put ATITD window in focus first and Press Shift key to unpin/close all pinned windows.");
	srReadScreen();
	window_locs = findAllImages("DropUnpin.png");
	clickAllRight("DropUnpin.png", 1);
	lsSleep(200);
end


function SmashMediumStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropMediumStone.png");
		if #buttons > 0 then
			clickAll("DropMediumStone.png")
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);

		srClickMouse(xyWindowSize[0]/2 + -20, xyWindowSize[1]/2 + -60);
		lsSleep(per_click_delay);

		end
		srReadScreen();
		buttons = findOneImage("DropSmashThis.png");
		if #buttons > 0 then
		statusScreen("Medium Stones Smashed: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function SmashCrackedStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropCrackedStone.png");
		if #buttons > 0 then
			clickAll("DropCrackedStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);

		srClickMouse(xyWindowSize[0]/2 + -20, xyWindowSize[1]/2 + -45);
		lsSleep(per_click_delay);
		
		end
		srReadScreen();
		buttons = findOneImage("DropSmashThis.png");
		if #buttons > 0 then
		statusScreen("Cracked Stones Smashed: " .. count);
			srClickMouseNoMove("DropSmashThis.png");
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
count = count + 1;
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function SmashBrokenStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropBrokenStone.png");
		if #buttons > 0 then
			clickAll("DropBrokenStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);

		srClickMouse(xyWindowSize[0]/2 + -25, xyWindowSize[1]/2 + -35);
		lsSleep(per_click_delay);

		end
		srReadScreen();
		buttons = findOneImage("DropSmashThis.png");
		if #buttons > 0 then
		statusScreen("Broken Stones Smashed: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(500);
		count = count + 1;
		end
	end
end

function SmashSplitStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropSplitStone.png");
		if #buttons > 0 then
			clickAll("DropSplitStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);

		srClickMouse(xyWindowSize[0]/2 + -18, xyWindowSize[1]/2 + -40);
		lsSleep(per_click_delay)

		end
		srReadScreen();
		buttons = findOneImage("DropSmashThis.png");
		if #buttons > 0 then
		statusScreen("Split Stones Smashed: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(500);
		count = count + 1;
		end
	end
end

function SmashSmashedStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropSmashedStone.png");
		if #buttons > 0 then
			clickAll("DropSmashedStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);

		srClickMouse(xyWindowSize[0]/2 + -18, xyWindowSize[1]/2 + -35);
		lsSleep(per_click_delay)

		end
		srReadScreen();
		buttons = findOneImage("DropSmashThis.png");
		if #buttons > 0 then
		statusScreen("Smashed Stones Smashed: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(500);
		count = count + 1;
		end
	end
end

function DropMediumStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropMediumStone.png");
		if #buttons > 0 then
			clickAll("DropMediumStone.png")
			lsSleep(10);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
		statusScreen("Medium Stones Dropped: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function DropCrackedStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropCrackedStone.png");
		if #buttons > 0 then
			clickAll("DropCrackedStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
		statusScreen("Cracked Stones Dropped: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function DropBrokenStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropBrokenStone.png");
		if #buttons > 0 then
			clickAll("DropBrokenStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
		statusScreen("Broken Stones Dropped: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function DropSplitStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropSplitStone.png");
		if #buttons > 0 then
			clickAll("DropSplitStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
		statusScreen("Split Stones Dropped: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function DropSmashedStone()
	num_loops = promptNumber("How many passes ?", 1);
	askText();
	local count = 0;
	for i=1, num_loops do
		srReadScreen();
		checkBreak();
		buttons = findOneImage("DropSmashedStone.png");
		if #buttons > 0 then
			clickAll("DropSmashedStone.png");
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
		statusScreen("Smashed Stones Dropped: " .. count);
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end


function DropSledgehammer()
        askForWindow("Drop your sledgehammer to mark the spot to return to after you have collected the stone fragments. To save time, leave the gravel on the ground and collect it all at once after all of the smashing is done, this also saves you from becoming 'pinned' if you are overloaded with both it and stone fragemnts while collecting. Click in ATITD and press shift to begin.");
	local num_rounds;
	local count = 0;
	while true do
		statusScreen("Hammer Dropped");
		srReadScreen();
		buttons = findOneImage("DropSledgehammer.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		end
		srReadScreen();
		buttons = findOneImage("DropOk.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
			return;
		end
	end
end 


function doit()
	while 1 do
		-- Ask for which button
		local image_name = nil;
		local is_done = nil;	
		while not is_done do
			local y = 40;
			local x = nil;
			local bsize = nil;
			for i=1, #button_names do
				if button_names[i] == "Smash Medium Stone" then
					x = 30;
					y = 0;
				elseif button_names[i] == "Smash Cracked Stone" then
					x = 30;
					y = 25;
				elseif button_names[i] == "Smash Broken Stone" then
					x = 30;
					y = 50;
				elseif button_names[i] == "Smash Split Stone" then
					x = 30;
					y = 75;
				elseif button_names[i] == "Smash Smashed Stone" then
					x = 30;
					y = 100;
				elseif button_names[i] == "Drop Medium Stone" then
					x = 30;
					y = 125;
				elseif button_names[i] == "Drop Cracked Stone" then
					x = 30;
					y = 150;
				elseif button_names[i] == "Drop Broken Stone" then
					x = 30;
					y = 175;
				elseif button_names[i] == "Drop Split Stone" then
					x = 30;
					y = 200;
				elseif button_names[i] == "Drop Smashed Stone" then
					x = 30;
					y = 225;
					end
				if lsButtonText(2, y, 0, 296, 0xFDD017ff, button_names[i]) then
					image_name = button_names[i];
					is_done = 1;
				end

			end

			if lsButtonText(lsScreenX - 298, lsScreenY - 100, z, 296, 0xFFA500ff, "Drop Sledgehammer") then
					DropSledgehammer();
					is_done = 1;
			end
			if lsButtonText(lsScreenX - 298, lsScreenY - 75, z, 296, 0xFFA500ff, "Collect Stones & Gravel") then
					gather();
					is_done = 1;
			end
			if lsButtonText(lsScreenX - 298, lsScreenY - 50, z, 296, 0xFFA500ff, "Un-Pin Windows") then
					Unpin();
					is_done = 1;
			end
			if lsButtonText(lsScreenX - 298, lsScreenY - 25, z, 296, 0xFF0000ff, "End Script") then
				error "Clicked End Script button";
			end

			lsDoFrame();
			lsSleep(10);
		end	
		
		if image_name == "Smash Medium Stone" then
			SmashMediumStone();
		elseif image_name == "Smash Cracked Stone" then
			SmashCrackedStone();
		elseif image_name == "Smash Broken Stone" then
			SmashBrokenStone();
		elseif image_name == "Smash Split Stone" then
			SmashSplitStone();
		elseif image_name == "Smash Smashed Stone" then
			SmashSmashedStone();
		elseif image_name == "Drop Medium Stone" then
			DropMediumStone();
		elseif image_name == "Drop Cracked Stone" then
			DropCrackedStone();
		elseif image_name == "Drop Broken Stone" then
			DropBrokenStone();
		elseif image_name == "Drop Split Stone" then
			DropSplitStone();
		elseif image_name == "Drop Smashed Stone" then
			DropSmashedStone();
		elseif image_name == "Drop Sledgehammer" then
			DropSledgehammer();
		elseif image_name == "Collect Stones & Gravel" then
			gather();
		elseif image_name == "Un-Pin Windows" then
			Unpin();
		end
	end
end


local distance_scale = 0.75; -- only scans pixels within a distance of this percentage from the center of the screen

function getCenterPos()
	local ret = {};
	ret[0] = xyWindowSize[0] / 2;
	ret[1] = xyWindowSize[1] / 2;
	return ret;
end

function isWithinRange(x, y)
	local radius = xyWindowSize[0] * 0.15;
	local dx, dy, d;
	dx = x - getCenterPos()[0];
	dy = y - getCenterPos()[1];
	if (dx*dx + dy*dy <= radius*radius) then
		return 1;
	end
	
	return nil;
end


function clickAll(image_name, up, right_click)
	-- Find buttons and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		-- statusScreen("Could not find specified buttons...");
		-- lsSleep(1500);
	else
		--statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				if (buttons[i][0] > 200) then
					srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
					lsSleep(per_click_delay);
				end
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
				lsSleep(per_click_delay);
			end
		end
		--statusScreen("Done clicking (" .. #buttons .. " clicks).");
		--lsSleep(100);
	end
end

function clickMouseSplatter(x, y, right)
	-- srSetMousePos(x, y);
	srClickMouse(x + math.random(-2, 2), y + math.random(-2, 2), right);
end

function gather()
	askForWindow("Use F8F8 camera zoomed in almost all the way...about 80 - 90%.  You may need to zoom back & forth slighty if you stop moving or if the script fails to find the stones/gravel. and large piles of gravel may still need to be manually 'Scooped up' using hotkeys 'S'. Right-Click opens a Menu as Pinned must be OFF. Right-Click Pins/Unpins a Menu must be OFF. Time-of-Day Lighting must be at LOWEST (OFF). Shadow Quality must be at LOWEST (OFF). Male avatars need to remove their turban if they are wearing one or the script will attempt to collect your head ;)                                                                                               Click in the ATITD window                             Then Press Shift To Begin.");

	srReadScreen();

	while true do
		local frame_start = lsGetTimer();
		statusScreen("Watching for Stones");
		possible_papy = lsAnalyzeSilt(7, 40, 1, xyWindowSize[0] * distance_scale);
		local clicked = nil;
		if possible_papy then
			for i = 1, #possible_papy do
				-- bias because it seems to drag to the upper left, take this off
				--  if I fix the downsampling
				possible_papy[i][0] = possible_papy[i][0] + 5;
				--possible_papy[i][1] = possible_papy[i][1] + 5;
				if isWithinRange(possible_papy[i][0], possible_papy[i][1]) then
				
					-- srClickMouse(possible_papy[i][0], possible_papy[i][1], 1);
					-- srSetMousePos(possible_papy[i][0], possible_papy[i][1]);

					-- code to try to make sure the pixel is the right color
					-- off by a few pixels in translation, maybe?  needs to be pixel accurate!
					local good;
					local r, g, b;
					if nil then
						pxval = srReadPixel(possible_papy[i][0], possible_papy[i][1]);
						a = pxval % 256;
						pxval = (pxval - a) / 256;
						b = pxval % 256;
						pxval = (pxval - b) / 256;
						g = pxval % 256;
						pxval = (pxval - g) / 256;
						r = pxval % 256;
						if (r > 130 and g > 130 and b < 20 and math.abs(r - g) < 20) then
							good = 1;
						end
					else
						r = 0;
						g = 0;
						b = 0;
						good = 1;
					end
					
					if good then
						lsPrint(10, 80 + i*20, 0, 0.7, 0.7, 0xFFFFFFff, possible_papy[i][0] .. ", " .. possible_papy[i][1] .. " : " .. r .. "," .. g .. "," .. b);
						clickMouseSplatter(possible_papy[i][0], possible_papy[i][1], 1);
						clicked = 1;
					else
						lsPrint(10, 80 + i*20, 0, 0.7, 0.7, 0xFF7F7Fff, possible_papy[i][0] .. ", " .. possible_papy[i][1] .. " : " .. r .. "," .. g .. "," .. b);
					end
				else 
					lsPrint(10, 80 + i*20, 0, 0.7, 0.7, 0x7F7F7Fff, possible_papy[i][0] .. ", " .. possible_papy[i][1] );
				end
			end

				if lsButtonText(lsScreenX - 298, lsScreenY - 30, z, 150, 0xFFFFFFff, "Menu") then
				-- if lsButtonText(5, lsScreenY - 60, z, 180, 0xFFFFFFff, "Menu") then
					doit();
					is_done = 1;
				end
			end

		lsSleep(100);
		if clicked then
		lsSleep(100);
		end
	end
end
